/* Program name --- breaksilence.c
 *       written by Sakurai   2006.2.22
 */

#include        <stdio.h>
#include        <string.h>
#include        <stdlib.h>
#include        <math.h>

#define       REST           1
#define       CYCLE          2

extern double gasdev_m();
void error(char *);

main(argc,argv)
int	argc;
char	*argv[];
{

  int i, j, len, period, p, cycle=CYCLE;
  int seed=-10;
  float delta, theta, val, noise, variance;
  float magnif, rest=(float)REST;

  if(argc != 5){
    error(argv[0]);
    exit(1);
  }
  len = atoi(argv[1]);
  period = atoi(argv[2]);
  magnif = atof(argv[3]);
  variance = atof(argv[4]);
  if (len < period || magnif == 0){
    printf("Error : length %d, period %d, magnification %f\n", 
	   len, period, magnif);
    exit(1);
  }

  p = period;
  i = 1;
  for (j=0 ; j<p/cycle ; j++){
    noise = gasdev_m(&seed) * variance;
    printf("%f\n", noise);
    if (i >= len)
      break;
    i++;
  }
  while(1){
    delta = M_PI * 2 / (float)p;
    for (j=0 ; j<p*cycle ; j++){
      theta = delta * j;
      val = sin(theta);
      noise = gasdev_m(&seed) * variance;
      printf("%f\n", val+noise);
      if (i >= len)
	break;
      i++;
    }
    if (i >= len)
      break;
    for (j=0 ; j<p*rest*cycle ; j++){
      noise = gasdev_m(&seed) * variance;
      printf("%f\n", noise);
      if (i >= len)
	break;
      i++;
    }
    if (i >= len)
      break;
    p *= magnif;
  }
}     

void error(char *toolname){
  fprintf(stderr,"Usage   : %s  length  period  magnification  noise\n",toolname);
  fprintf(stderr,"Example : %s  1024  64  1.2  1\n",toolname);
  exit(1);
}

