/* Program name --- sindata.c
 *       written by Sakurai   2002.8.6
 */

#include        <stdio.h>
#include        <string.h>
#include        <stdlib.h>
#include        <math.h>

extern double gasdev_m();
void error(char *);

main(argc,argv)
int	argc;
char	*argv[];
{

  int i, j, leng, iter, num;
  int seed=-1;
  float delta, theta, val, noise, variance;

  if(argc != 4){
    error(argv[0]);
    exit(1);
  }
  iter = atoi(argv[1]);
  leng = atoi(argv[2]);
  variance = atof(argv[3]);
  if (leng % iter != 0){
    printf("Error : length %d, iteration %d\n", leng, iter);	
    exit(1);
  }
  num = leng / iter;
  delta = M_PI * 2 / (double)num;
  for (i=0 ; i<iter ; i++){
    for (j=0 ; j<num ; j++){
      theta = delta * j;
      val = sin(theta);
      noise = gasdev_m(&seed) * variance;
      printf("%f\n", val+noise);
    }
  }
}     

void error(char *toolname){
    fprintf(stderr,"Usage : %s  iteration  length  noise\n",toolname);
    exit(1);
}

